

#include <mega8.h>
#include <delay.h>
#include <string.h>

#include "DEFINE.h"
#include "fontR.h"



//=============================   8  ===================================

void lcd_write_cmd(unsigned char c){
 CS=0;
 DAT=0;//_Off;
 CLK=1;//_On;
 CLK=0;//_Off;
 
 SPI_ON;
 SPDR = c;
 SPI_WAIT;
 SPI_OFF;
 CS=1;
}



//=============================   8  ====================================

void lcd_write_dat(unsigned char c){
 CS=0;
 DAT=1;//_On;
 CLK=1;//_On;
 CLK=0;//_Off;
 
 SPI_ON;
 SPDR = c;
 SPI_WAIT;
 SPI_OFF;
 CS=1;
}

//============================   16  ====================================

void lcd_write16(unsigned int dat){
  lcd_write_dat(dat>>8);
  lcd_write_dat(dat);
} 
//================================ =========================================
/*
void lcd_init_rgb(void)
{ 
   CS= 0;
   RESET=0;
   delay_ms(5);
   RESET=1;
   delay_ms(5); 
   CS= 1;
   delay_ms(5);       //reset  
  
  
 lcd_write_cmd(0xBA); lcd_write_dat(0b00000111); lcd_write_dat(0b00010101);//Data Order
 lcd_write_cmd(0x25); lcd_write_dat(0b00111111); //Contrast  
 lcd_write_cmd(0x36); lcd_write_dat(0b10100000);// < >,  RGB, 
 lcd_write_cmd(0x11); //Sleep out
 lcd_write_cmd(0x13); //Displey Normal Mode
 lcd_write_cmd(0x37); lcd_write_dat(0b00000000); //VSROLL ADDR
 lcd_write_cmd(0x3A); lcd_write_dat(0b00000101);//16bit
 fill_screen(bgcolor);
 lcd_write_cmd(0x29);// DISP ON
 lcd_write_cmd(0x20);// INV OFF
 lcd_write_cmd(0x13);// NOR ON
 }
*/



void lcd_init_rgb(void)
{ 
  
  CS=0;//_Off; 
  RESET=0;
  delay_ms(5);
  RESET=1;
  delay_ms(5);
  CS=1;//_On;
  lcd_write_cmd(0x01);
  delay_ms(5);       //reset  
//  CS=0;//_Off;

  
/*  
  lcd_write_cmd(0xBA); //   
  lcd_write_dat(0x07);
  lcd_write_dat(0x15);
  lcd_write_cmd(0x25); // 
  lcd_write_dat(0x3F);
  lcd_write_cmd(0x11); //    sleep, (0x10) sleep
  lcd_write_cmd(0x14);
  
  lcd_write_cmd(0x37); //  
  lcd_write_dat(0x00);
  lcd_write_cmd(0x3A);
  lcd_write_dat(0x05);
  
  lcd_write_cmd(0x36); //  
  lcd_write_dat(0xA0); //   90 
 
  fill_screen(bgcolor);
  lcd_write_cmd(0x29); //  , (0x28) 
  lcd_write_cmd(0x20); //  , (0x21) 
  lcd_write_cmd(0x13);
*/
 //=======================   ========================================
 lcd_write_cmd(0x11); //Sleep out
 lcd_write_cmd(0x3A); lcd_write_dat(0x05);//16bit05      COLMOD pixel format 04=12,05=16,06=18
 lcd_write_cmd(0x36); lcd_write_dat(0xA0);
 fill_screen(bgcolor);
 lcd_write_cmd(0x29);// DISP ON
 //==========================================================================
// CS=0;  
 } 

 
//=================================== ============================================

 void fill_screen(unsigned int color)
 {   
   unsigned char j,i;    
    lcd_write_cmd(0x2A); //x-
    lcd_write16(1);
    lcd_write16(160);

    lcd_write_cmd(0x2B);//Y-
    lcd_write16(1);
    lcd_write16(131);
   
          lcd_write_cmd(0x2C);

  for (i=0; i<DISP_H; i++)
  {
   for(j=0;j<DISP_W;j++)
   {
    lcd_write16(color);
   }
  } 
 }




 
void LCD_XY(unsigned char x, unsigned char y)
 {
    lcd_write_cmd(0x2A); //x-
    lcd_write16(x+2);
    lcd_write16(x+2);

    lcd_write_cmd(0x2B);//Y-
    lcd_write16(y+1);
    lcd_write16(y+1);
 }


    
void LCD_Pixel(char x, char y,int color)
 {
  LCD_XY(x,y);
  lcd_write_cmd(0x2C);// WR_MEM

  lcd_write16(color);

 }
    
 
void LCD_Char(unsigned char x, unsigned char y, char c, unsigned int color,char m)
{
  unsigned char h,ch,p,mask,tt;      
        
    lcd_write_cmd(0x2A); //x-
    lcd_write16(x+2);
    lcd_write16(x+2+CHAR_W*m-1);

    lcd_write_cmd(0x2B);//Y-
    lcd_write16(y+1);
    lcd_write16(y+1+CHAR_H*m-1);
                   
                        
      lcd_write_cmd(0x2C);
    
    
    
    
    

 // for (h=0; h<CHAR_H*m; h++) // every column of the character
 // {
 //         ch=FONT8x14[ c-32 ][h/m];
  
    for (h=CHAR_H; h>0; h--) {    // every column of the character

    for(tt=0;tt<m;tt++) {

 
 
      
        
      if (c == 32) {
        ch=ascii_tab[0][CHAR_H-h];    
      }

      else if (c > 44 && c < 59) {
        ch=ascii_tab[c-44][CHAR_H-h];
      } 

      else if (c == 176) {
        ch=ascii_tab[15][CHAR_H-h];
      }

      else if (c > 191) {
        ch=ascii_tab[c-176][CHAR_H-h];
      }
  
                  
        mask = 0x80;
               
        for (p=0; p<CHAR_W; p++)  // write the pixels
        {
          if (ch & mask)
          { 
           lcd_write16(color);
           if(m==2)
           { lcd_write16(color); } 
           if(m==3)
           { lcd_write16(color);lcd_write16(color); } 
          }
          
          else
          {
           lcd_write16(bgcolor);
           if(m==2)
           { lcd_write16(bgcolor);}
           if(m==3) 
           { lcd_write16(bgcolor); lcd_write16(bgcolor);}
           
          }
          mask=mask/2;
        }
  } } 
  
}

void put_string(unsigned char x, unsigned char y, char *str, unsigned int color,char m)
{
 unsigned char j;
  j=0;
  while (j<strlen(str))
  {
    LCD_Char(x+j*CHAR_W*m,y,str[j], color,m);
    j++;
  }
}

 
 
  void lcd_line(char x1,char y1,char x2,char y2,unsigned int color)
{

signed int  x,y,d,dx,dy,i,i1,i2,kx,ky;
signed char  flag;

dx = x2 - x1;
dy = y2 - y1;
if (dx == 0 && dy == 0) LCD_Pixel(x1, y1, color);
else
{
kx = 1;
ky = 1;
if( dx < 0 )
{
dx = -dx;
kx = -1;
}
else
if(dx == 0) kx = 0;
if(dy < 0)
{
dy = -dy;
ky = -1;
}
if(dx < dy)
{
flag = 0;
d = dx;
dx = dy;
dy = d;
}
else flag = 1;
i1 = dy + dy;
d = i1 - dx;
i2 = d - dx;
x = x1;
y = y1;

for(i=0; i < dx; i++)
{
LCD_Pixel(x, y, color);
if(flag) x += kx;
else y += ky;
if( d < 0 ) d += i1;
else
{
d += i2;
if(flag) y += ky;
else x += kx;
}
}
LCD_Pixel(x, y, color);
}
}
